'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.LibraryInitGenerator = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      ******************************************************************************
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      Copyright (c) 2016 Particle Industries, Inc.  All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      This program is free software; you can redistribute it and/or
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      modify it under the terms of the GNU Lesser General Public
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      License as published by the Free Software Foundation, either
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      version 3 of the License, or (at your option) any later version.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      This program is distributed in the hope that it will be useful,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      but WITHOUT ANY WARRANTY; without even the implied warranty of
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      Lesser General Public License for more details.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      You should have received a copy of the GNU Lesser General Public
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      License along with this program; if not, see <http://www.gnu.org/licenses/>.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      ******************************************************************************
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _validation = require('./validation');

var _template_processor = require('./util/template_processor');

var _os = require('os');

var os = _interopRequireWildcard(_os);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var path = require('path');

function lowercaseFirstLetter(string) {
	return string.charAt(0).toLowerCase() + string.slice(1);
}

function capitalizeFirstLetter(string) {
	return string.charAt(0).toUpperCase() + string.slice(1);
}

/**
 * Formats a message from the validation error.
 * @param {object} v    The result from a validateField call.
 * @returns {string}    The error message string
 */
function validationMessage(v) {
	return v.field + ': ' + v.errors[v.field];
}

function validationError(validation) {
	var msg = [];
	for (var idx in validation) {
		var v = validation[idx];
		var m = validationMessage(v);
		msg.push(m);
	}
	var error = new Error(msg);
	error.validate = validation;
	return error;
}

/**
 * Code the functionality separate from the generator so we can mock the various
 * generator operations - having to subclass Base binds the functionality too closely
 * to the generator.
 */

var LibraryInitGenerator = exports.LibraryInitGenerator = function () {
	function LibraryInitGenerator(_ref) {
		var prompt = _ref.prompt,
		    stdout = _ref.stdout;

		_classCallCheck(this, LibraryInitGenerator);

		this.arguments = [];
		this.sourceRoot = path.join(__dirname, 'init', 'templates');
		this.prompt = prompt;
		this.stdout = stdout; // TODO (hmontero): Remove both stdout and prompt in order to make particle-library manager just handle library creation and not prompt for anything
	}

	_createClass(LibraryInitGenerator, [{
		key: 'destinationRoot',
		value: function destinationRoot(rootPath) {
			this._destinationRoot = rootPath;
		}
	}, {
		key: 'destinationPath',
		value: function destinationPath(file) {
			return path.join(this._destinationRoot || process.cwd(), file);
		}
	}, {
		key: 'templatePath',
		value: function templatePath(file) {
			return path.join(this.sourceRoot, file);
		}
	}, {
		key: 'argument',
		value: function argument(name, options) {
			this.arguments.push({ name: name, options: options });
		}

		/**
   * Registers the option names.
   * @private
   * @returns {undefined} nothing
   */

	}, {
		key: '_initializeOptions',
		value: function _initializeOptions() {
			this.argument('name', { type: String, required: false });
			this.argument('version', { type: String, required: false });
			this.argument('year', { type: Number, required: false });
			this.argument('dir', { type: String, required: false });
		}
	}, {
		key: '_setYear',
		value: function _setYear() {
			var currentDate = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new Date();

			if (this.options.year === undefined) {
				this.options.year = currentDate.getFullYear();
			}
		}
	}, {
		key: '_setOutputDir',
		value: function _setOutputDir() {
			if (this.options.dir !== undefined) {
				this.destinationRoot(this.options.dir);
			}
		}
	}, {
		key: '_promptValidate',
		value: function _promptValidate(field, value) {
			var result = this._validateField(field, value);
			if (!result || result.valid) {
				return true;
			}
			return validationMessage(result);
		}
	}, {
		key: '_allPrompts',
		value: function _allPrompts() {
			var _this = this;

			var prompt = [];

			if (this.options.name === undefined) {
				prompt.push({
					type: 'input',
					name: 'name',
					message: 'Enter a name for your library:',
					validate: function validate(value) {
						return _this._promptValidate('name', value);
					}
				});
			}

			if (this.options.version === undefined) {
				prompt.push({
					type: 'input',
					name: 'version',
					message: 'Enter a version for your library:',
					validate: function validate(value) {
						return _this._promptValidate('version', value);
					}
				});
			}

			if (this.options.author === undefined) {
				prompt.push({
					type: 'input',
					name: 'author',
					message: 'Who is the author of your library:',
					validate: function validate(value) {
						return _this._promptValidate('author', value);
					}
				});
			}

			return prompt;
		}

		/**
   * Handle the result of prompts.
   * @param {object} data The result of the prompts.
   * @private
   * @returns {undefined} nothing
   */

	}, {
		key: '_handlePrompts',
		value: function _handlePrompts(data) {
			Object.assign(this.options, data);
			if (this.options.name) {
				this.options.name_code = lowercaseFirstLetter(this.options.name.replace(/[^a-zA-Z0-9_]/g, ''));
				this.options.Name_code = capitalizeFirstLetter(this.options.name_code);
			}
			this._checkFields();
		}
	}, {
		key: '_checkFields',
		value: function _checkFields() {
			var result = this._validate();
			if (result.length) {
				throw validationError(result);
			}
		}
	}, {
		key: '_validate',
		value: function _validate() {
			var options = ['name', 'version', 'author'];
			var result = [];
			for (var idx in options) {
				var check = this._validateOption(options[idx]);
				if (check && !check.valid) {
					result.push(check);
				}
			}
			return result;
		}
	}, {
		key: '_validateOption',
		value: function _validateOption(attribute) {
			var value = this.options[attribute];
			if (value !== undefined && value !== null) {
				return this._validateField(attribute, value.toString());
			}
			return null;
		}
	}, {
		key: '_validateField',
		value: function _validateField(field, value) {
			return (0, _validation.validateField)(field, value);
		}
	}, {
		key: '_prompt',
		value: function _prompt() {
			var _this2 = this;

			this._setYear();
			this._setOutputDir();
			var prompt = this._allPrompts();
			if (prompt.length) {
				return this.prompt(prompt).then(function (data) {
					return _this2._handlePrompts(data);
				});
			}
			return this._handlePrompts({});
		}
	}, {
		key: 'write',
		value: async function write() {
			await (0, _template_processor.processTemplate)({
				templatePath: this.templatePath('library.properties'),
				destinationPath: this.destinationPath('library.properties'),
				options: this.options
			});
			this.stdout.write('Created library.properties' + os.EOL);

			await (0, _template_processor.processTemplate)({
				templatePath: this.templatePath('README.md'),
				destinationPath: this.destinationPath('README.md'),
				options: this.options
			});
			this.stdout.write('Created README.md' + os.EOL);

			await (0, _template_processor.processTemplate)({
				templatePath: this.templatePath('LICENSE'),
				destinationPath: this.destinationPath('LICENSE'),
				options: this.options
			});
			this.stdout.write('Created LICENSE' + os.EOL);

			var filename = path.join('src', this.options.name + '.cpp');
			await (0, _template_processor.processTemplate)({
				templatePath: this.templatePath(path.join('src', 'library.cpp')),
				destinationPath: this.destinationPath(filename),
				options: this.options
			});
			this.stdout.write('Created ' + filename + os.EOL);

			var libraryFileName = path.join('src', this.options.name + '.h');
			await (0, _template_processor.processTemplate)({
				templatePath: this.templatePath(path.join('src', 'library.h')),
				destinationPath: this.destinationPath(libraryFileName),
				options: this.options
			});
			this.stdout.write('Created ' + libraryFileName + os.EOL);

			var exampleFileName = path.join('examples', 'usage', 'usage.ino');
			await (0, _template_processor.processTemplate)({
				templatePath: this.templatePath(exampleFileName),
				destinationPath: this.destinationPath(exampleFileName),
				options: this.options
			});
			this.stdout.write('Created ' + exampleFileName + os.EOL);
		}
	}, {
		key: 'run',
		value: async function run() {
			var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
			    options = _ref2.options;

			this.options = options || {};
			await this._prompt();
			await this.write();
		}
	}]);

	return LibraryInitGenerator;
}();

// keep all branches  of the ES6 transpilled code executed
/* istanbul ignore next: not executed on node 7 */


exports.default = function () {};